Imports System.Runtime.InteropServices

Public Module [Lib]
  'Option Explicit

  'Fehlerliste  Dll Funktionsaufrufe
  Public Const TSLF_NO_ERROR = 0
  Public Const TSLF_PORT_OEFFNEN = 1
  Public Const TSLF_TIMEOUT_UNGUELTIG = 5
  Public Const TSLF_PORTHANDLE_UNGUELTIG = 6
  Public Const TSLF_TIMEOUT = 7
  Public Const TSLF_BUFFER_ZU_KLEIN = 8
  Public Const TSLF_BUFFERGROESSE_FALSCH = 9
  Public Const TSLF_FALSCHER_TRANSPONDERTYP = 10
  Public Const TSLF_KEINE_SENDEDATEN = 11
  Public Const TSLF_BLOCKNUMMER_UNGUELTIG = 12
  Public Const TSLF_LOCK_UNGUELTIG = 13
  Public Const TSLF_CHECKSUMMENFEHLER = 14
  Public Const TSLF_KEINE_KOMMUNIKATION = 15
  Public Const TSLF_CHECKBUFFER_LEER = 16
  Public Const TSLF_NULL_POINTER = 17
  Public Const TSLF_MODE_UNGUELTIG = 18
  Public Const TSLF_DONT_SET_USB = 19
  Public Const TSLF_COMPARE_ERROR = 20

  'Leserfehler
  Public Const TSLF_NACK = 21
  Public Const TSLF_SYNC = 22
  Public Const TSLF_LOCKED = 23
  Public Const TSLF_CANCEL = 24
  Public Const TSLF_INVALID_DATA = 25

  'Definitionen
  Public Const TTYP_DEFAULT = 0
  Public Const TTYP_HITAG_2 = 2
  Public Const TTYP_Q5 = 3
  Public Const TTYP_HITAG_S = 4
  Public Const TTYP_HITAG_1 = 5
  Public Const TTYP_TITAN = 6
  Public Const TTYP_4569 = 7
  Public Const TTYP_EM4305 = 8
  Public Const TTYP_ATA5577 = 9
  Public Const TTYP_HITAG_Y = 10
  Public Const TTYP_ATA5575 = 11
  Public Const TTYP_SIC7888 = 12
  Public Const TTYP_ATA5551 = 13

  Public Const TTYP_HDX_TIRIS = 33
  Public Const TTYP_HDX_INCIDE = 34
  Public Const TTYP_HDX_PLUS = 35
  Public Const TTYP_HDX_SIC7900 = 36
  Public Const TTYP_HDX_PLUS_HIQ = 37
  Public Const TTYP_HDX_SIC7999 = 38

  Public Const TTYP_ATA5577_PW = 48

  Public Const READ_AFTER_WRITE = 256
  Public Const READ_AFTER_WRITE_INVERS = 512
  Public Const READ_INVERS = 1024
  Public Const DO_ALL_ERRORS = 2048
  Public Const NO_RETRY = 4096
  Public Const DO_OVERLAPPED = 8192
  Public Const NO_READ_AFTER_WRITE = 16384
  Public Const NO_FACTORY_ID = 32768

  Public Const ANSWER_MODE_MANCHESTER2KBIT = &H0  ' Manchester     RF/64
  Public Const ANSWER_MODE_BIPHASE4KBIT = &H1     ' Diff. Biphase  RF/32
  Public Const ANSWER_MODE_FSK2A = &H2            ' FSK 2A         RF/50
  Public Const ANSWER_MODE_HDX = &H3              ' HDX
  Public Const ANSWER_MODE_FSK_MANCHESTER = &H4   ' FSK 2A         RF/50 + Manchester Dekodierung
  Public Const ANSWER_MODE_MANCHESTER4KBIT = &H5  ' Manchester     RF/32
  Public Const ANSWER_MODE_BIPHASE2KBIT = &H6     ' Diff. Biphase  RF/64
  Public Const ANSWER_MODE_FSK2A2KBIT = &H7       ' FSK 2A         RF/64
  Public Const ANSWER_MODE_INVERS = &H80          ' Additional invers Flag

  'Parameter fr TSLF_ReadFormattedData()
  Public Const TSLF_FORMAT_UNIQUE = &H1
  Public Const TSLF_FORMAT_GIS16BIT = &H2
  Public Const TSLF_FORMAT_UNIQUEXL = &H3
  Public Const TSLF_FORMAT_ANIMAL_FDXB = &H4
  Public Const TSLF_FORMAT_ANIMAL_FDXA = &H5
  Public Const TSLF_FORMAT_ANIMAL_HDX = &H6

  Public Const TSLF_READ_BY_DEFAULT = &H0
  Public Const TSLF_READ_BY_CMD = &H100
  Public Const TSLF_READ_UID = &H200

  'possible values for Lock in WriteFSK commands
  Public Const TSLF_WRITEFSK_LOCK_NONE = 0
  Public Const TSLF_WRITEFSK_LOCK_DATA = 1
  Public Const TSLF_WRITEFSK_LOCK_CONFIG = 2
  Public Const TSLF_WRITEFSK_LOCK_ALL = 3

  'Rckgabewerte
  Public Const TSLF_RETVAL_ERROR = -1
  Public Const TSLF_RETVAL_OK = 0
  Public Const TSLF_RETVAL_FORMAT_FALSCH = 1
  Public Const TSLF_RETVAL_LOCKED = 2
  Public Const TSLF_RETVAL_SAME_TAG = 3
  Public Const TSLF_RETVAL_PROCESS_PENDING = 4
  Public Const TSLF_RETVAL_INVALID_DATA = 5

  '// Get Library Version
  Public Declare Function TSLF_LibVersion Lib "TS_LF_SDK.DLL" () As Integer

  Public Declare Function TSLF_IsVirtualComInstalled Lib "TS_LF_SDK.DLL" () As Integer

  '// Get Names of all USB Devices connected, only valid devices are listed
  Public Declare Function TSLF_GetUSBDeviceNames Lib "TS_LF_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all USB Devices connected, all devices from GiS are listed
  Public Declare Function TSLF_GetUSBDeviceNamesEx Lib "TS_LF_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all COM Ports available, not tested if there is a device at the port connected.
  Public Declare Function TSLF_GetCOMDeviceNames Lib "TS_LF_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all valid LAN devices found in same subnet
  Public Declare Function TSLF_GetLanDeviceNames Lib "TS_LF_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all LAN devices found even in other subnets
  Public Declare Function TSLF_GetLanDeviceNamesEx Lib "TS_LF_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Change IP Address of LAN device
  Public Declare Function TSLF_ChangeLanIPAddress Lib "TS_LF_SDK.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> ByRef IPMask As Byte) As Integer

  '// Change IP Address and Gateway of LAN device
  Public Declare Function TSLF_ChangeLanIPAddressEx Lib "TS_LF_SDK.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> ByRef IPMask As Byte, <[In]()> ByRef GatewayAddress As Byte) As Integer

  '// Get IP Address and Gateway of LAN device
  Public Declare Function TSLF_GetLanIPAddressEx Lib "TS_LF_SDK.DLL" (<[In]()> ByRef strName As Byte, <Out()> ByRef Address As Byte, <Out()> ByRef IPMask As Byte, <Out()> ByRef GatewayAddress As Byte) As Integer

  '// Check if specific LAN device is available
  Public Declare Function TSLF_IsLanDeviceAvailable Lib "TS_LF_SDK.DLL" (<[In]()> ByRef Address As Byte) As Integer

  '// Open LAN Device for configuration
  Public Declare Function TSLF_LanConfigOpen Lib "TS_LF_SDK.DLL" (<[In]()> ByRef strName As Byte) As Integer

  '// Set Configuration Record of LAN device, use with care!
  Public Declare Function TSLF_LanConfigGet Lib "TS_LF_SDK.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <Out()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Get Configuration Record of LAN device
  Public Declare Function TSLF_LanConfigSet Lib "TS_LF_SDK.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <[In]()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Close LAN device configuration.
  Public Declare Function TSLF_LanConfigClose Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal Reset As Integer) As Integer

  '// Read Configuration of USB HID device
  Public Declare Function TSLF_HIDConfigRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer
  '// Write Configuration to USB HID device
  Public Declare Function TSLF_HIDConfigWrite Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer) As Integer

  Public Declare Function TSLF_Open Lib "TS_LF_SDK.DLL" (<[In]()> ByRef Name As Byte, ByVal Baudrate As Integer, ByVal ParityMode As Integer, ByVal Timeout As Integer) As Integer
  Public Declare Function TSLF_Close Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer) As Integer
  Public Declare Function TSLF_KeepAppActive Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal bActive As Integer) As Integer
  Public Declare Function TSLF_SetReaderAdresse Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal Adresse As Integer) As Integer

  Public Delegate Function AutoReadCallback (<MarshalAs(UnmanagedType.LPStr)> Arr As String, ByVal Len As Integer) As Integer 

  Public Declare Function TSLF_StartAutoRead Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TermChar As Integer, pAutoReadProc As AutoReadCallback) As Integer
  Public Declare Function TSLF_StopAutoRead Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSLF_GetDeviceVersion Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pDevVer As Byte, ByVal VerLen As Integer, <Out()> ByRef pDevName As Byte, ByVal NameLen As Integer) As Integer
  Public Declare Function TSLF_IsProgrammer Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSLF_IsReader Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSLF_IsUSB Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSLF_GetFilter Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef pParam As Byte, ByVal nParamLen As Integer) As Integer
  Public Declare Function TSLF_SetFilter Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, pParam As Byte, ByVal nParamLen As Integer) As Integer
  Public Declare Function TSLF_SetBaudrate Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal Baudrate As Integer, ByVal ParityMode As Integer) As Integer
  Public Declare Function TSLF_SetWriteDelay Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal delay As Integer) As Integer
  Public Declare Function TSLF_SetReaderMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal Mode As Integer) As Integer
  Public Declare Function TSLF_SetRF Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal OnOff As Integer) As Integer
  Public Declare Function TSLF_GetLastError Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer) As Integer
  Public Declare Function TSLF_SetIO Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal Maske As Integer, ByVal Daten As Integer) As Integer
  Public Declare Function TSLF_ReadIO Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pDaten As Integer) As Integer
  Public Declare Function TSLF_TestIO Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Testwert As Integer) As Integer

  Public Declare Function TSLF_SetLED Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal red As Integer, ByVal green As Integer, ByVal yellow As Integer) As Integer
  Public Declare Function TSLF_Beep Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSLF_ClearLCD Lib "TS_LF_SDK.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSLF_SetLCDFont Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal FontNr As Integer) As Integer
  Public Declare Function TSLF_SetLCDText Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal StartLine As Integer, <[In]()> ByRef strText As Byte) As Integer
  Public Declare Function TSLF_SetLCDLight Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal Helligkeit As Integer) As Integer

  Public Declare Function TSLF_ReadSerialNumber Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pSerial As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_SetConfig Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer
  Public Declare Function TSLF_GetConfig Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer
  Public Declare Function TSLF_SetDefault Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer) As Integer
  Public Declare Function TSLF_SetAnswerMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal AnswerMode As Integer) As Integer
  Public Declare Function TSLF_GetAnswerMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer) As Integer

  Public Declare Function TSLF_ReadMagnetCard Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ClearMagnetCard Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer) As Integer

  Public Declare Function TSLF_GetActivationContext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pData As Byte, ByVal Len As Integer) As Integer
  Public Declare Function TSLF_WriteActivationContext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pData As Byte, ByVAl Len As Integer)As Integer
  Public Declare Function TSLF_ReadCounter Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByRef pCounter As Integer) As Integer
  Public Declare Function TSLF_DecrementCounter Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByRef pNewCounter As Integer) As Integer
  Public Declare Function TSLF_GetDaysRemain Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByRef pDaysRemain As Integer) As Integer
  Public Declare Function TSLF_UpdateDaysRemain Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByRef pDaysRemain As Integer) As Integer

  Public Declare Function TSLF_SetCommunicationMode Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal Mode As Integer) As Integer
  Public Declare Function TSLF_RawRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_RawWrite Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Transfer Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal Cmd As Integer, pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer

  Public Declare Function TSLF_Read Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, ByVal BlockNr As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Write Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, ByVal BlockNr As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_GetTagType Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTypExpected As Integer) As Integer
  Public Declare Function TSLF_GetTagAnswerMode Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal AnswerModeExpected As Integer) As Integer

  Public Declare Function TSLF_Write_Unique Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FastUnique Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_UniqueXL Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_GiS16Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_GiS12Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_GiS72Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_NC34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK35Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal FixedField As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CustomerNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_FSK37BitHuge Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <[In]()> ByRef pCode As Byte, ByVal CodeLen As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_IDCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CardNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_AWID26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CardNr As Integer, ByVal bLock As Integer) As Integer
  Public Declare Function TSLF_Write_AWID40Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal FacilityCode As Integer, ByVal CardNr As Integer, ByVal bLock As Integer) As Integer


  Public Declare Function TSLF_Read_TTFData Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal AnswerMode As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_Unique Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_FastUnique Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_UniqueXL Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_GiS16Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_GiS12Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_GiS72Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Read_FSK26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_FSK34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_NC34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_FSK35Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_FSK36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer, <Out()> ByRef pFixedField As Integer) As Integer
  Public Declare Function TSLF_Read_FSK37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_FSK37BitHuge Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pCode As Byte, ByVal CodeLen As Integer) As Integer
  Public Declare Function TSLF_Read_IDCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_AWID26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer
  Public Declare Function TSLF_Read_AWID40Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pFacilityCode As Integer, <Out()> ByRef pCardNr As Integer) As Integer

  Public Declare Function TSLF_ReadFormattedData Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal ReadType As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSLF_ResetTransponder Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer) As Integer

  Public Declare Function TSLF_UID_Request Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef UID As Byte, ByVal UIDLen As Integer) As Integer
  Public Declare Function TSLF_UID_RequestAC Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef UID As Byte, ByVal UIDLen As Integer) As Integer
  Public Declare Function TSLF_UID_RequestNext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef UID As Byte, ByVal UIDLen As Integer) As Integer
  Public Declare Function TSLF_Select Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <[In]()> ByRef UID As Byte, ByVal UIDLen As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSLF_WakeUp Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <[In]()> ByRef pPasswort As Byte, ByVal PasswortLen As Integer) As Integer
  Public Declare Function TSLF_WakeUpAndRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <[In]()> ByRef pPasswort As Byte, ByVal PasswortLen As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSLF_Login Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <[In]()> ByRef pPW As Byte, ByVal nPWLen As Integer) As Integer
  Public Declare Function TSLF_WritePW Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <[In]()> ByRef pOldPW As Byte, ByVal OldPWLen As Integer, <[In]()> ByRef pNewPW As Byte, ByVal NewPWLen As Integer) As Integer

  Public Declare Function TSLF_Disable Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer) As Integer
  Public Declare Function TSLF_Lock Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TransponderTyp As Integer, ByVal BlockNr As Integer) As Integer

  Public Declare Function TSLF_GetTagInfo Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef pSysInfo As Byte, ByVal SysInfoLen As Integer) As Integer
  Public Declare Function TSLF_SetCTune Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, ByVal CTuneVal As Integer, ByVal bUseValue As Integer, ByVal bOne As Integer, ByVal bLock As Integer, <Out()> ByRef pFrequenz As Integer) As Integer
  Public Declare Function TSLF_AutoTune Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef pFrequenz0 As Integer, <Out()> ByRef pFrequenz1 As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_WriteParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WritePrefix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadPrefix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WriteSuffix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadSuffix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WriteTermix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadTermix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WritePostcode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadPostcode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WriteReadModeParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_ReadReadModeParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WriteHitag2Key Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_WriteTagKey Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

  '// Functions for ISO11784 (Animal code)
  Public Declare Function TSLF_Read_FDXA Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSLF_Write_FDXA Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef pFactoryID As Byte, <[In]()> ByRef pIDNummer As Byte, ByVal IdLen As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_Read_FDXB Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pCountryCode As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer, <Out()> ByRef pAnimalFlag As Integer, <Out()> ByRef pDatenblockFlag As Integer, <Out()> ByRef pReserved As Integer, <Out()> ByRef pExtension As Integer) As Integer
  Public Declare Function TSLF_Write_FDXB Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef pFactoryID As Byte, ByVal CountryCode As Integer, <[In]()> ByRef pIDNummer As Byte, ByVal IDNummerLen As Integer, ByVal AnimalFlag As Integer, ByVal DatenblockFlag As Integer, ByVal Reserved As Integer, ByVal Extension As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_Read_HDX Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pCountryCode As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer, <Out()> ByRef pAnimalFlag As Integer, <Out()> ByRef pDatenblockFlag As Integer, <Out()> ByRef pReserved As Integer, <Out()> ByRef pExtension As Integer) As Integer
  Public Declare Function TSLF_Write_HDX Lib "TS_LF_SDK.DLL" (ByVal handle As Integer, ByVal TTyp As Integer, <Out()> ByRef pFactoryID As Byte, ByVal CountryCode As Integer, <[In]()> ByRef pIDNummer As Byte, ByVal IDNummerLen As Integer, ByVal AnimalFlag As Integer, ByVal DatenblockFlag As Integer, ByVal Reserved As Integer, ByVal Extension As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_Read_EN14803 Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pManufacturer As Integer, <Out()> ByRef pSerialNumber As Integer) As Integer
  Public Declare Function TSLF_Read_EN14803HDX Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef pManufacturer As Integer, <Out()> ByRef pSerialNumber As Integer) As Integer
  Public Declare Function TSLF_Write_EN14803 Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, ByVal TTyp As Integer, <Out()> ByRef pFactoryID As Byte, ByVal Manufacturer As Integer, ByVal SerialNumber As Integer, ByVal bLock As Integer) As Integer

  Public Declare Function TSLF_IsWriteFinished Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pFactoryID As Byte) As Integer

End Module
